Index: /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/BaseClasses/ShapeBase.cs
===================================================================
--- /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/BaseClasses/ShapeBase.cs	(revision 4067)
+++ /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/BaseClasses/ShapeBase.cs	(revision 4068)
@@ -1,543 +1,484 @@
 using System;
-using System.Diagnostics;
+using System.ComponentModel;
 using System.Drawing;
-using System.ComponentModel;
 using System.Windows.Forms;
-using System.Drawing.Drawing2D;
-namespace Netron.Diagramming.Core
-{
-    // ----------------------------------------------------------------------
-    /// <summary>
-    /// Abstract base class for shapes.
-    /// </summary>
-    // ----------------------------------------------------------------------
-    public abstract partial class ShapeBase : DiagramEntityBase, IShape
-    {
-        #region Fields
-
-        // ------------------------------------------------------------------
-        /// <summary>
-        /// Implementation of IVersion - the current version of 
-        /// ShapeBase.
-        /// </summary>
-        // ------------------------------------------------------------------
-        protected const double shapeBaseVersion = 1.0;
-
-        // ------------------------------------------------------------------
-        /// <summary>
-        /// Specifies if connectors are drawn.
-        /// </summary>
-        // ------------------------------------------------------------------
-        protected bool mShowConnectors = true; 
-
-        // ------------------------------------------------------------------
-        /// <summary>
-        /// The collection of Connectors onto which you can attach a 
-        /// connection.
-        /// </summary>
-        // ------------------------------------------------------------------
-        protected CollectionBase<IConnector> mConnectors;
-
-        protected bool mIsFixed = false;
-
-        #endregion
-
-        #region Properties
-
-        // ------------------------------------------------------------------
-        /// <summary>
-        /// Gets the current version.
-        /// </summary>
-        // ------------------------------------------------------------------
-        public override double Version
-        {
-            get
-            {
-                return shapeBaseVersion;
-            }
+namespace Netron.Diagramming.Core {
+  // ----------------------------------------------------------------------
+  /// <summary>
+  /// Abstract base class for shapes.
+  /// </summary>
+  // ----------------------------------------------------------------------
+  public abstract partial class ShapeBase : DiagramEntityBase, IShape {
+    #region Fields
+
+    // ------------------------------------------------------------------
+    /// <summary>
+    /// Implementation of IVersion - the current version of 
+    /// ShapeBase.
+    /// </summary>
+    // ------------------------------------------------------------------
+    protected const double shapeBaseVersion = 1.0;
+
+    // ------------------------------------------------------------------
+    /// <summary>
+    /// Specifies if connectors are drawn.
+    /// </summary>
+    // ------------------------------------------------------------------
+    protected bool mShowConnectors = true;
+
+    // ------------------------------------------------------------------
+    /// <summary>
+    /// The collection of Connectors onto which you can attach a 
+    /// connection.
+    /// </summary>
+    // ------------------------------------------------------------------
+    protected CollectionBase<IConnector> mConnectors;
+
+    protected bool mIsFixed = false;
+
+    #endregion
+
+    #region Properties
+
+    // ------------------------------------------------------------------
+    /// <summary>
+    /// Gets the current version.
+    /// </summary>
+    // ------------------------------------------------------------------
+    public override double Version {
+      get {
+        return shapeBaseVersion;
+      }
+    }
+
+    // ------------------------------------------------------------------
+    /// <summary>
+    /// Gets the image for this shape when displaying in a library (i.e.
+    /// toolbox).
+    /// </summary>
+    // ------------------------------------------------------------------
+    public virtual Image LibraryImage {
+      get {
+        return null;
+      }
+    }
+
+    // ------------------------------------------------------------------
+    /// <summary>
+    /// Gets or sets if the connectors are drawn.
+    /// </summary>
+    // ------------------------------------------------------------------
+    public bool ShowConnectors {
+      get {
+        return this.mShowConnectors;
+      }
+      set {
+        bool oldValue = mShowConnectors;
+        this.mShowConnectors = value;
+        if (oldValue != value) {
+          Invalidate();
         }
-
-        // ------------------------------------------------------------------
-        /// <summary>
-        /// Gets the image for this shape when displaying in a library (i.e.
-        /// toolbox).
-        /// </summary>
-        // ------------------------------------------------------------------
-        public virtual Image LibraryImage
-        {
-            get
-            {
-                return null;
-            }
+        RaiseOnChange(this, new EntityEventArgs(this));
+      }
+    }
+
+    // ------------------------------------------------------------------
+    /// <summary>
+    /// Gets or sets the canvas to which the entity belongs
+    /// </summary>
+    /// <value></value>
+    // ------------------------------------------------------------------
+    public override IModel Model {
+      get {
+        return base.Model;
+      }
+      set {
+        base.Model = value;
+        if (Connectors == null)
+          throw new InconsistencyException("The connectors collection is 'null'.");
+        foreach (IConnector con in Connectors) {
+          con.Model = value;
         }
-
-        // ------------------------------------------------------------------
-        /// <summary>
-        /// Gets or sets if the connectors are drawn.
-        /// </summary>
-        // ------------------------------------------------------------------
-        public bool ShowConnectors
-        {
-            get
-            {
-                return this.mShowConnectors;
-            }
-            set
-            {
-                bool oldValue = mShowConnectors;
-                this.mShowConnectors = value;
-                if (oldValue != value)
-                {
-                    Invalidate();
-                }
-                RaiseOnChange(this, new EntityEventArgs(this));
-            }
+      }
+    }
+
+    // ------------------------------------------------------------------
+    /// <summary>
+    /// Gets or sets the Connectors attached to this shape.
+    /// </summary>		
+    // ------------------------------------------------------------------
+    public CollectionBase<IConnector> Connectors {
+      get { return mConnectors; }
+      set { mConnectors = value; }
+    }
+
+    // ------------------------------------------------------------------
+    /// <summary>
+    /// Gets or sets the width of the bundle
+    /// </summary>
+    // ------------------------------------------------------------------
+    [Browsable(true),
+    Description("The width of the shape"),
+    Category("Layout")]
+    public int Width {
+      get {
+        return this.mRectangle.Width;
+      }
+      set {
+        Transform(
+            this.Rectangle.X,
+            this.Rectangle.Y,
+            value,
+            this.Height);
+      }
+    }
+
+    // ------------------------------------------------------------------
+    /// <summary>
+    /// Gets or sets the height of the bundle
+    /// </summary>		
+    // ------------------------------------------------------------------
+    [Browsable(true),
+    Description("The height of the shape"),
+    Category("Layout")]
+    public int Height {
+      get {
+        return this.mRectangle.Height;
+      }
+      set {
+        Transform(
+            this.Rectangle.X,
+            this.Rectangle.Y,
+            this.Width,
+            value);
+      }
+    }
+
+    // ------------------------------------------------------------------
+    /// <summary>
+    /// the x-coordinate of the upper-left corner
+    /// </summary>
+    // ------------------------------------------------------------------
+    [Browsable(true),
+    Description("The x-coordinate of the upper-left corner"),
+    Category("Layout")]
+    public int X {
+      get {
+        return mRectangle.X;
+      }
+      set {
+        Point p = new Point(value - mRectangle.X, mRectangle.Y);
+        this.MoveBy(p);
+
+        //if(Model!=null)
+        //  Model.RaiseOnInvalidate(); //note that 'this.Invalidate()' will not be enough
+      }
+    }
+
+    // ------------------------------------------------------------------
+    /// <summary>
+    /// the y-coordinate of the upper-left corner
+    /// </summary>
+    // ------------------------------------------------------------------
+    [Browsable(true), Description("The y-coordinate of the upper-left corner"), Category("Layout")]
+    public int Y {
+      get {
+        return mRectangle.Y;
+      }
+      set {
+        Point p = new Point(mRectangle.X, value - mRectangle.Y);
+        this.MoveBy(p);
+        //Model.RaiseOnInvalidate();
+      }
+    }
+
+    // ------------------------------------------------------------------
+    /// <summary>
+    /// Gets or sets the location of the bundle;
+    /// </summary>
+    // ------------------------------------------------------------------
+    [Browsable(false)]
+    public Point Location {
+      get {
+        return new Point(this.mRectangle.X, this.mRectangle.Y);
+      }
+      set {
+        //we use the move method but it requires the delta value, not 
+        // an absolute position!
+        Point p = new Point(
+            value.X - mRectangle.X,
+            value.Y - mRectangle.Y);
+
+        // If you'd use this it would indeed move the bundle but not 
+        // the connectors of the bundle 
+        // this.mRectangle.X = value.X; this.mRectangle.Y = value.Y; Invalidate();
+        this.MoveBy(p);
+      }
+    }
+
+    // ------------------------------------------------------------------
+    /// <summary>
+    /// Gets the bounds of the paintable entity
+    /// </summary>
+    /// <value></value>
+    // ------------------------------------------------------------------
+    public override Rectangle Rectangle {
+      get {
+        return mRectangle;
+      }
+      //set{mRectangle = value;
+
+      //this.Invalidate();              }
+    }
+
+    #endregion
+
+    #region Constructor
+
+
+    /// <summary>
+    /// Constructor with the site of the bundle
+    /// </summary>
+    /// <param name="model"></param>
+    protected ShapeBase(IModel model)
+      : base(model) {
+    }
+
+    /// <summary>
+    /// Initializes a new instance of the <see cref="T:ShapeBase"/> class.
+    /// </summary>
+    protected ShapeBase()
+      : base() {
+    }
+
+    /// <summary>
+    /// Inits this instance.
+    /// </summary>
+    protected override void Initialize() {
+      base.Initialize();
+      mConnectors = new CollectionBase<IConnector>();
+      mConnectors.OnItemAdded += new EventHandler<CollectionEventArgs<IConnector>>(mConnectors_OnItemAdded);
+      mRectangle = new Rectangle(0, 0, 100, 70);
+    }
+
+    #endregion
+
+    #region Methods
+
+    // ------------------------------------------------------------------
+    /// <summary>
+    /// Overrides the base 'OnBeforeDelete' to tell all attached
+    /// connectors they're being deleted.
+    /// </summary>
+    /// <param name="deleteCommand"></param>
+    // ------------------------------------------------------------------
+    public override void OnBeforeDelete(DeleteCommand deleteCommand) {
+      base.OnBeforeDelete(deleteCommand);
+      foreach (IConnector con in this.mConnectors) {
+        con.OnBeforeDelete(deleteCommand);
+      }
+    }
+
+    // ------------------------------------------------------------------
+    /// <summary>
+    /// Overrides the base 'OnAfterDelete' to tell all attached
+    /// connectors they have been deleted.
+    /// </summary>
+    /// <param name="deleteCommand"></param>
+    // ------------------------------------------------------------------
+    public override void OnAfterDelete(DeleteCommand deleteCommand) {
+      base.OnAfterDelete(deleteCommand);
+      foreach (IConnector con in this.mConnectors) {
+        con.OnAfterDelete(deleteCommand);
+      }
+    }
+
+    // ------------------------------------------------------------------
+    /// <summary>
+    /// Generates a new Uid for this entity.
+    /// </summary>
+    /// <param name="recursive">bool: If the Uid has to be changed  
+    /// recursively down to the sub-entities, set to true, otherwise 
+    /// false.</param>
+    // ------------------------------------------------------------------
+    public override void NewUid(bool recursive) {
+
+      if (recursive) {
+        foreach (IConnector connector in Connectors) {
+          connector.NewUid(recursive);
         }
-
-        // ------------------------------------------------------------------
-        /// <summary>
-        /// Gets or sets the canvas to which the entity belongs
-        /// </summary>
-        /// <value></value>
-        // ------------------------------------------------------------------
-        public override IModel Model
-        {
-            get
-            {
-                return base.Model;
-            }
-            set
-            {
-                base.Model = value;
-                if (Connectors == null)
-                    throw new InconsistencyException("The connectors collection is 'null'.");
-                foreach (IConnector con in Connectors)
-                {
-                    con.Model = value;
-                }
-            }
+        base.NewUid(recursive);
+      } else
+        base.NewUid(recursive);
+    }
+
+    // ------------------------------------------------------------------
+    /// <summary>
+    /// Part of the initialization, this method connects newly added 
+    /// connectors to the parenting shape.
+    /// </summary>
+    /// <param name="sender">object</param>
+    /// <param name="e">CollectionEventArgs<IConnector></param>
+    // ------------------------------------------------------------------
+    void mConnectors_OnItemAdded(
+        object sender,
+        CollectionEventArgs<IConnector> e) {
+      e.Item.Parent = this;
+    }
+
+    // ------------------------------------------------------------------
+    /// <summary>
+    /// The custom menu to be added to the base menu of this entity.
+    /// 'null' is returned here.
+    /// </summary>
+    /// <returns>ToolStripItem[]</returns>
+    // ------------------------------------------------------------------
+    public override ToolStripItem[] Menu() {
+      return null;
+    }
+
+    // ------------------------------------------------------------------
+    /// <summary>
+    /// Returns the connector hit by the mouse, if any.
+    /// </summary>
+    /// <param name="p">Point: The mouse coordinates</param>
+    /// <returns>IConnector: The connector hit by the mouse</returns>
+    // ------------------------------------------------------------------
+    public IConnector HitConnector(Point p) {
+      for (int k = 0; k < mConnectors.Count; k++) {
+        if (mConnectors[k].Hit(p)) {
+          mConnectors[k].Hovered = true;
+          mConnectors[k].Invalidate();
+          return mConnectors[k];
+        } else {
+          mConnectors[k].Hovered = false;
+          mConnectors[k].Invalidate();
+
         }
 
-        // ------------------------------------------------------------------
-        /// <summary>
-        /// Gets or sets the Connectors attached to this shape.
-        /// </summary>		
-        // ------------------------------------------------------------------
-        public CollectionBase<IConnector> Connectors
-        {
-            get { return mConnectors; }
-            set { mConnectors = value; }
-        }
-
-        // ------------------------------------------------------------------
-        /// <summary>
-        /// Gets or sets the width of the bundle
-        /// </summary>
-        // ------------------------------------------------------------------
-        [Browsable(true), 
-        Description("The width of the shape"), 
-        Category("Layout")]
-        public int Width
-        {
-            get 
-            { 
-                return this.mRectangle.Width; 
-            }
-            set 
-            { 
-                Transform(
-                    this.Rectangle.X, 
-                    this.Rectangle.Y, 
-                    value,
-                    this.Height);
-            }
-        }
-
-        // ------------------------------------------------------------------
-        /// <summary>
-        /// Gets or sets the height of the bundle
-        /// </summary>		
-        // ------------------------------------------------------------------
-        [Browsable(true), 
-        Description("The height of the shape"), 
-        Category("Layout")]
-        public int Height
-        {
-            get 
-            { 
-                return this.mRectangle.Height; 
-            }
-            set
-            {
-                Transform(
-                    this.Rectangle.X, 
-                    this.Rectangle.Y, 
-                    this.Width,
-                    value);
-            }
-        }
-
-        // ------------------------------------------------------------------
-        /// <summary>
-        /// the x-coordinate of the upper-left corner
-        /// </summary>
-        // ------------------------------------------------------------------
-        [Browsable(true), 
-        Description("The x-coordinate of the upper-left corner"), 
-        Category("Layout")]
-        public int X
-        {
-            get 
-            { 
-                return mRectangle.X; 
-            }
-            set
-            {
-                Point p = new Point(value - mRectangle.X, mRectangle.Y);
-                this.MoveBy(p);
-
-                //if(Model!=null)
-                //  Model.RaiseOnInvalidate(); //note that 'this.Invalidate()' will not be enough
-            }
-        }
-
-        // ------------------------------------------------------------------
-        /// <summary>
-        /// the y-coordinate of the upper-left corner
-        /// </summary>
-        // ------------------------------------------------------------------
-        [Browsable(true), Description("The y-coordinate of the upper-left corner"), Category("Layout")]
-        public int Y
-        {
-            get 
-            { 
-                return mRectangle.Y;
-            }
-            set
-            {
-                Point p = new Point(mRectangle.X, value - mRectangle.Y);
-                this.MoveBy(p);
-                //Model.RaiseOnInvalidate();
-            }
-        }
-
-        // ------------------------------------------------------------------
-        /// <summary>
-        /// Gets or sets the location of the bundle;
-        /// </summary>
-        // ------------------------------------------------------------------
-        [Browsable(false)]
-        public Point Location
-        {
-            get 
-            { 
-                return new Point(this.mRectangle.X, this.mRectangle.Y); 
-            }
-            set
-            {
-                //we use the move method but it requires the delta value, not 
-                // an absolute position!
-                Point p = new Point(
-                    value.X - mRectangle.X, 
-                    value.Y - mRectangle.Y);
-
-                // If you'd use this it would indeed move the bundle but not 
-                // the connectors of the bundle 
-                // this.mRectangle.X = value.X; this.mRectangle.Y = value.Y; Invalidate();
-                this.MoveBy(p);
-            }
-        }
-
-        // ------------------------------------------------------------------
-        /// <summary>
-        /// Gets the bounds of the paintable entity
-        /// </summary>
-        /// <value></value>
-        // ------------------------------------------------------------------
-        public override Rectangle Rectangle
-        {
-            get 
-            {
-                return mRectangle; 
-            }
-            //set{mRectangle = value;
-
-            //this.Invalidate();              }
-        }        
-      
-        #endregion
-
-        #region Constructor
-
-
-        /// <summary>
-        /// Constructor with the site of the bundle
-        /// </summary>
-        /// <param name="model"></param>
-        protected ShapeBase(IModel model)
-            : base(model)
-        {
-        }
-
-        /// <summary>
-        /// Initializes a new instance of the <see cref="T:ShapeBase"/> class.
-        /// </summary>
-        protected ShapeBase()
-            : base()
-        {
-        }
-
-        /// <summary>
-        /// Inits this instance.
-        /// </summary>
-        protected override void Initialize()
-        {
-            base.Initialize();
-            mConnectors = new CollectionBase<IConnector>();
-            mConnectors.OnItemAdded += new EventHandler<CollectionEventArgs<IConnector>>(mConnectors_OnItemAdded);
-            mRectangle = new Rectangle(0, 0, 100, 70);
-        }
-
-        #endregion
-
-        #region Methods
-
-        // ------------------------------------------------------------------
-        /// <summary>
-        /// Overrides the base 'OnBeforeDelete' to tell all attached
-        /// connectors they're being deleted.
-        /// </summary>
-        /// <param name="deleteCommand"></param>
-        // ------------------------------------------------------------------
-        public override void OnBeforeDelete(DeleteCommand deleteCommand)
-        {
-            base.OnBeforeDelete(deleteCommand);
-            foreach (IConnector con in this.mConnectors)
-            {
-                con.OnBeforeDelete(deleteCommand);
-            }
-        }
-
-        // ------------------------------------------------------------------
-        /// <summary>
-        /// Overrides the base 'OnAfterDelete' to tell all attached
-        /// connectors they have been deleted.
-        /// </summary>
-        /// <param name="deleteCommand"></param>
-        // ------------------------------------------------------------------
-        public override void OnAfterDelete(DeleteCommand deleteCommand)
-        {
-            base.OnAfterDelete(deleteCommand);
-            foreach (IConnector con in this.mConnectors)
-            {
-                con.OnAfterDelete(deleteCommand);
-            }
-        }
-
-        // ------------------------------------------------------------------
-        /// <summary>
-        /// Generates a new Uid for this entity.
-        /// </summary>
-        /// <param name="recursive">bool: If the Uid has to be changed  
-        /// recursively down to the sub-entities, set to true, otherwise 
-        /// false.</param>
-        // ------------------------------------------------------------------
-        public override void NewUid(bool recursive)
-        {
+
+      }
+      return null;
+    }
+
+    // ------------------------------------------------------------------
+    /// <summary>
+    /// Overrides the abstract paint method.  Nothing performed here,
+    /// let the sub-shapes do the painting.
+    /// </summary>
+    /// <param name="g">a graphics object onto which to paint</param>
+    // ------------------------------------------------------------------
+    public override void Paint(Graphics g) {
+      return;
+    }
+
+    // ------------------------------------------------------------------
+    /// <summary>
+    /// Override the abstract Hit method.  Here a simple hit test is
+    /// performed by checking if our "Rectangle" contains the point
+    /// specified.  Override this to perform more complex hit testing.
+    /// </summary>
+    /// <param name="p">Point</param>
+    /// <returns>bool</returns>
+    // ------------------------------------------------------------------
+    public override bool Hit(Point p) {
+      Rectangle r = new Rectangle(p, new Size(5, 5));
+      return Rectangle.Contains(r);
+    }
+
+    // ------------------------------------------------------------------
+    /// <summary>
+    /// Overrides the abstract Invalidate method.  This shape's rectangle
+    /// is inflated (not permanently) by a size of (40, 40) to ensure
+    /// the whole area is refreshed.
+    /// </summary>
+    // ------------------------------------------------------------------
+    public override void Invalidate() {
+      Rectangle r = Rectangle;
+      r.Offset(-10, -10);
+      r.Inflate(40, 40);
+      if (Model != null) {
+        Model.RaiseOnInvalidateRectangle(r);
+      }
+    }
+
+    // ------------------------------------------------------------------
+    /// <summary>
+    /// Moves the entity with the given shift (offset).
+    /// </summary>
+    /// <param name="p">Represents a shift-vector, not the absolute 
+    /// position!</param>
+    // ------------------------------------------------------------------
+    public override void MoveBy(Point p) {
+      Rectangle recBefore = mRectangle;
+      recBefore.Inflate(20, 20);
+
+      this.mRectangle.X += p.X;
+      this.mRectangle.Y += p.Y;
+
+      UpdatePaintingMaterial();
+
+      for (int k = 0; k < this.mConnectors.Count; k++) {
+        mConnectors[k].MoveBy(p);
+      }
+      RaiseOnChange(this, new EntityEventArgs(this));
+      //refresh things
+      this.Invalidate(recBefore);//position before the move
+      this.Invalidate();//current position
+
+    }
+
+    // ------------------------------------------------------------------
+    /// <summary>
+    /// Scales the entity with the given factor at the given origin.
+    /// <remarks>More an historical milestone than used code.</remarks>
+    /// </summary>
+    /// <param name="origin">The origin.</param>
+    /// <param name="scaleX">The scale X.</param>
+    /// <param name="scaleY">The scale Y.</param>
+    // ------------------------------------------------------------------
+    void Scale(
+        Point origin,
+        double scaleX,
+        double scaleY) {
+      #region Variables
+      //temporary variables to assign the new location of the mConnectors            
+      double a, b;
+      //the new location of the connector
+      Point p;
+      //calculated/scaled/biased corners of the new rectangle
+      double ltx = 0, lty = 0, rbx = 0, rby = 0;
+
+      Rectangle currentRectangle = Rectangle;
+      //we only need to transform the LT and RB corners since the rest of the rectangle can be deduced from that
+      /*
+      PointF[] corners = new PointF[]{new PointF(currentRectangle.X, currentRectangle.Y),                                                            
+                                                      new PointF(currentRectangle.Right, currentRectangle.Bottom),                                                            
             
-            if (recursive)
-            {
-                foreach (IConnector connector in Connectors)
-                {
-                    connector.NewUid(recursive);
-                }
-                base.NewUid(recursive);
-            }
-            else
-                base.NewUid(recursive);
-        }
-
-        // ------------------------------------------------------------------
-        /// <summary>
-        /// Part of the initialization, this method connects newly added 
-        /// connectors to the parenting shape.
-        /// </summary>
-        /// <param name="sender">object</param>
-        /// <param name="e">CollectionEventArgs<IConnector></param>
-        // ------------------------------------------------------------------
-        void mConnectors_OnItemAdded(
-            object sender, 
-            CollectionEventArgs<IConnector> e)
-        {
-            e.Item.Parent = this;
-        }
-
-        // ------------------------------------------------------------------
-        /// <summary>
-        /// The custom menu to be added to the base menu of this entity.
-        /// 'null' is returned here.
-        /// </summary>
-        /// <returns>ToolStripItem[]</returns>
-        // ------------------------------------------------------------------
-        public override ToolStripItem[] Menu()
-        {
-            return null;
-        }
-
-        // ------------------------------------------------------------------
-        /// <summary>
-        /// Returns the connector hit by the mouse, if any.
-        /// </summary>
-        /// <param name="p">Point: The mouse coordinates</param>
-        /// <returns>IConnector: The connector hit by the mouse</returns>
-        // ------------------------------------------------------------------
-        public IConnector HitConnector(Point p)
-        {
-            for (int k = 0; k < mConnectors.Count; k++)
-            {
-                if (mConnectors[k].Hit(p))
-                {
-                    mConnectors[k].Hovered = true;
-                    mConnectors[k].Invalidate();
-                    return mConnectors[k];
-                }
-                else
-                {
-                    mConnectors[k].Hovered = false;
-                    mConnectors[k].Invalidate();
-
-                }
-
-
-            }
-            return null;
-        }
-
-        // ------------------------------------------------------------------
-        /// <summary>
-        /// Overrides the abstract paint method.  Nothing performed here,
-        /// let the sub-shapes do the painting.
-        /// </summary>
-        /// <param name="g">a graphics object onto which to paint</param>
-        // ------------------------------------------------------------------
-        public override void Paint(Graphics g)
-        {           
-            return;
-        }
-
-        // ------------------------------------------------------------------
-        /// <summary>
-        /// Override the abstract Hit method.  Here a simple hit test is
-        /// performed by checking if our "Rectangle" contains the point
-        /// specified.  Override this to perform more complex hit testing.
-        /// </summary>
-        /// <param name="p">Point</param>
-        /// <returns>bool</returns>
-        // ------------------------------------------------------------------
-        public override bool Hit(Point p)
-        {
-            Rectangle r = new Rectangle(p, new Size(5, 5));
-            return Rectangle.Contains(r);
-        }
-
-        // ------------------------------------------------------------------
-        /// <summary>
-        /// Overrides the abstract Invalidate method.  This shape's rectangle
-        /// is inflated (not permanently) by a size of (40, 40) to ensure
-        /// the whole area is refreshed.
-        /// </summary>
-        // ------------------------------------------------------------------
-        public override void Invalidate()
-        {
-            Rectangle r = Rectangle;
-            r.Offset(-10, -10);
-            r.Inflate(40, 40);
-            if (Model != null)
-            {
-                Model.RaiseOnInvalidateRectangle(r);
-            }
-        }
-
-        // ------------------------------------------------------------------
-        /// <summary>
-        /// Moves the entity with the given shift (offset).
-        /// </summary>
-        /// <param name="p">Represents a shift-vector, not the absolute 
-        /// position!</param>
-        // ------------------------------------------------------------------
-        public override void MoveBy(Point p)
-        {
-            Rectangle recBefore = mRectangle;
-            recBefore.Inflate(20, 20);
-
-            this.mRectangle.X += p.X;
-            this.mRectangle.Y += p.Y;
-
-            UpdatePaintingMaterial();
-
-            for (int k = 0; k < this.mConnectors.Count; k++)
-            {
-                mConnectors[k].MoveBy(p);
-            }
-            RaiseOnChange(this, new EntityEventArgs(this));
-            //refresh things
-            this.Invalidate(recBefore);//position before the move
-            this.Invalidate();//current position
-
-        }
-
-        // ------------------------------------------------------------------
-        /// <summary>
-        /// Scales the entity with the given factor at the given origin.
-        /// <remarks>More an historical milestone than used code.</remarks>
-        /// </summary>
-        /// <param name="origin">The origin.</param>
-        /// <param name="scaleX">The scale X.</param>
-        /// <param name="scaleY">The scale Y.</param>
-        // ------------------------------------------------------------------
-        void Scale(
-            Point origin, 
-            double scaleX, 
-            double scaleY)
-        {
-            #region Variables
-            //temporary variables to assign the new location of the mConnectors            
-            double a, b;
-            //the new location of the connector
-            Point p;
-            //calculated/scaled/biased corners of the new rectangle
-            double ltx = 0, lty = 0, rbx = 0, rby = 0;
-
-            Rectangle currentRectangle = Rectangle;
-            //we only need to transform the LT and RB corners since the rest of the rectangle can be deduced from that
-            /*
-            PointF[] corners = new PointF[]{new PointF(currentRectangle.X, currentRectangle.Y),                                                            
-                                                            new PointF(currentRectangle.Right, currentRectangle.Bottom),                                                            
-            
-             };
-             */
-            Rectangle newRectangle;
-            #endregion
-
-            #region Transformation matrix
-
-            ltx = Math.Round((currentRectangle.X - origin.X) * scaleX, 1) + origin.X;
-            lty = Math.Round((currentRectangle.Y - origin.Y) * scaleY, 1) + origin.Y;
-
-            rbx = Math.Round((currentRectangle.Right - origin.X) * scaleX, 1) + origin.X;
-            rby = Math.Round((currentRectangle.Bottom - origin.Y) * scaleY, 1) + origin.Y;
-
-            //corners[0] = new PointF
-            //Matrix m = new Matrix();
-            // m.Translate(-origin.X, -origin.Y,MatrixOrder.Append);
-            // m.Scale(scaleX, scaleY, MatrixOrder.Append);
-            // m.Translate(origin.X, origin.Y, MatrixOrder.Append);
-            #endregion
-
-            //transfor the LTRB points of the current rectangle
-            //m.TransformPoints(corners);
-
-            #region Bias
-            /*
+       };
+       */
+      Rectangle newRectangle;
+      #endregion
+
+      #region Transformation matrix
+
+      ltx = Math.Round((currentRectangle.X - origin.X) * scaleX, 1) + origin.X;
+      lty = Math.Round((currentRectangle.Y - origin.Y) * scaleY, 1) + origin.Y;
+
+      rbx = Math.Round((currentRectangle.Right - origin.X) * scaleX, 1) + origin.X;
+      rby = Math.Round((currentRectangle.Bottom - origin.Y) * scaleY, 1) + origin.Y;
+
+      //corners[0] = new PointF
+      //Matrix m = new Matrix();
+      // m.Translate(-origin.X, -origin.Y,MatrixOrder.Append);
+      // m.Scale(scaleX, scaleY, MatrixOrder.Append);
+      // m.Translate(origin.X, origin.Y, MatrixOrder.Append);
+      #endregion
+
+      //transfor the LTRB points of the current rectangle
+      //m.TransformPoints(corners);
+
+      #region Bias
+      /*
             if(currentRectangle.Y <= origin.Y + ViewBase.TrackerOffset && origin.Y - ViewBase.TrackerOffset <= currentRectangle.Y)
             {
